import java.applet.*;
import java.awt.*;

public class quiz extends Applet implements Runnable
{
	Thread				m_quiz					= null;

	private Graphics	m_Graphics;
	private Image		m_Images[];

	private int 		m_nImgWidth				= 0;
	private int 		m_nImgHeight			= 0;
	private int			m_iNumberOfQuestions	= 0;
	private int			m_iQNum					= 0;
	private	int			m_iCorrAns				= 0;
	private	int			m_iCorrect				= 0;
	private	int			m_iWrong				= 0;
	private int			m_iScoreTarget			= 70;
	private int			m_iRandom				= 0;
 	private	int[]		m_iaRandNums;
 	private final int	NUM_IMAGES				= 10;

	private	char		m_caQuestionTemp[];
	
	private boolean		m_fAllLoaded			= false;

	private	String		m_sInputString			= "";
	private	String		m_sAnswer1				= "";
	private	String		m_sAnswer2				= "";
	private	String		m_sAnswer3				= "";
	private	String		m_sQuestion				= "";
  	private final String PARAM_sQuestion		= "sQuestion";
	private final String PARAM_iScoreTarget		= "iScoreTarget";
	private final String PARAM_iRandom			= "iRandom";

	private Label		m_lAns1					= new Label("  ");
	private	Label		m_lAns2					= new Label("  ");
	private	Label		m_lAns3					= new Label("  ");
	private	Label		m_lQuestion				= new Label("  ");
	private	Label		m_lPlaceholder			= new Label("  ");
	private Label		m_lQofN					= new Label("  ");
	private Button		m_bAns1					= new Button("1");
	private Button		m_bAns2					= new Button("2");
	private Button		m_bAns3					= new Button("3");
	private Checkbox	m_cbSound				= new Checkbox("sound on");	
	
	public quiz()
	{
	}

	public String getAppletInfo()
	{
		return "Name: quiz\r\n" +
		       "Author: John McKendrick" +
			   "Copyright 1997, McKendrick";
	}

	public void init()
	{
		String param;

		param = getParameter(PARAM_sQuestion);
		if (param != null)
			m_sInputString = param;
		
		param = getParameter(PARAM_iScoreTarget);
		if (param != null)
			m_iScoreTarget = Integer.parseInt(param);

		param = getParameter(PARAM_iRandom);
		if (param != null)
			m_iRandom = Integer.parseInt(param);

		Panel panelAnswer1 = new Panel();
		panelAnswer1.setLayout(new BorderLayout());
		panelAnswer1.add("West", m_bAns1);
		panelAnswer1.add("Center", m_lAns1);
		
		Panel panelAnswer2 = new Panel();
		panelAnswer2.setLayout(new BorderLayout());
		panelAnswer2.add("West", m_bAns2);
		panelAnswer2.add("Center", m_lAns2);

		Panel panelAnswer3 = new Panel();
		panelAnswer3.setLayout(new BorderLayout());
		panelAnswer3.add("West", m_bAns3);
		panelAnswer3.add("Center", m_lAns3);

		Panel panelScore = new Panel();
		panelScore.setLayout(new GridLayout(0, 3));
		panelScore.add(m_lQofN);
		panelScore.add(m_lPlaceholder);
		panelScore.add(m_cbSound);
		panelScore.setBackground(Color.cyan);

		Panel panelAnswers = new Panel();
		panelAnswers.setLayout(new GridLayout(4, 0));
		panelAnswers.add(panelAnswer1);
		panelAnswers.add(panelAnswer2);
		panelAnswers.add(panelAnswer3);
		panelAnswers.add(panelScore);
		
		panelAnswers.setBackground(Color.white);
	
		setLayout(new BorderLayout());
		add("North", m_lQuestion);
		add("South", panelAnswers);

		setBackground(Color.white);

		m_bAns1.disable();
		m_bAns2.disable();
		m_bAns3.disable();
		m_cbSound.hide();

		resize(310, 160);

		getNumberOfQuestions();
	}

	public void destroy()
	{
	}

	public void paint(Graphics g)
	{
		setBackground(Color.white);

		if (m_fAllLoaded)
		{
			Rectangle r = g.getClipRect();
			
			g.clearRect(r.x, r.y, r.width - 1, r.height);
			g.drawImage(m_Images[0], 
					(size().width - m_nImgWidth) / 2,
						30, null);
			
			if (m_iRandom == 1) 
				randomize();
			else
				notRandom();


			int QToGet = m_iaRandNums[m_iQNum];
			getQuestion(QToGet);
			m_lQuestion.setText(m_sQuestion);
			m_bAns1.enable();
			m_bAns2.enable();
			if (m_sAnswer3.compareTo("") != 0)
				m_bAns3.enable();
			else
				m_bAns3.disable();
			m_cbSound.show();
			m_lAns1.setText(m_sAnswer1);
			m_lAns2.setText(m_sAnswer2);
			m_lAns3.setText(m_sAnswer3);
			m_lQofN.setText("question " + (m_iQNum + 1) + " sur " + m_iNumberOfQuestions);

		}
		else
			g.drawString("chargement des images...", 10, 50);

	}

	public void animate(int f, int l, int t)
	{
		int m_nFirstImage = f;
		int m_nLastImage = l;
		int m_nTimesToShow = t;
		int shownXTimes = 0;

		int m_nCurrImage = m_nFirstImage;
		
		m_nImgWidth  = m_Images[m_nCurrImage].getWidth(this);
		m_nImgHeight  = m_Images[m_nCurrImage].getHeight(this);

		while (true)
		{
			try
			{
				shownXTimes++;
				m_nCurrImage++;
				m_Graphics.drawImage(m_Images[m_nCurrImage],
				   (size().width - m_nImgWidth) / 2,
						22, null);
				if (m_nCurrImage == m_nLastImage)
					m_nCurrImage = m_nFirstImage;

				Thread.sleep(100);
				if (shownXTimes == m_nTimesToShow) 
				{
					m_bAns1.show();
					m_bAns2.show();
					m_bAns3.show();

					m_lQofN.setText("question " + (m_iQNum + 2) + " of " + m_iNumberOfQuestions);
					m_Graphics.clearRect((size().width - m_nImgWidth) / 2, 22, 
						((size().width - m_nImgWidth) / 2) + m_nImgWidth, (22 + m_nImgHeight));
					m_nImgWidth  = m_Images[0].getWidth(this);
					m_Graphics.drawImage(m_Images[0],
						(size().width - m_nImgWidth) / 2,
							30, null); 
					m_iQNum++;
					if (m_iQNum < m_iNumberOfQuestions)
					{
						int QToGet = m_iaRandNums[m_iQNum];
						getQuestion(QToGet);
						m_lQuestion.setText(m_sQuestion);
						m_lAns1.setText(m_sAnswer1);
						m_lAns2.setText(m_sAnswer2);
						m_lAns3.setText(m_sAnswer3);
						m_bAns1.enable();
						m_bAns2.enable();
						if (m_sAnswer3.compareTo("") != 0)
							m_bAns3.enable();
						else
							m_bAns3.disable();
						m_lQofN.setText("question " + (m_iQNum + 1) + " sur " + m_iNumberOfQuestions);
					}
					return;
				}
			}
			catch (InterruptedException e)
			{
				stop();
			}
		}
	}
	
	public void start()
	{
		if (m_quiz == null)
		{
			m_quiz = new Thread(this);
			m_quiz.start();
		}
	}
	
	public void stop()
	{
		if (m_quiz != null)
		{
			m_quiz.stop();
			m_quiz = null;
		}
		m_bAns1.show();
		m_bAns2.show();
		m_bAns3.show();
		m_bAns1.disable();
		m_bAns2.disable();
		m_bAns3.disable();
		m_iQNum	= 0;
		m_iCorrAns = 0;
		m_iCorrect = 0;
		m_iWrong = 0;
		m_quiz.destroy();
		destroy();
	}

	public void run()
	{
        if (!m_fAllLoaded)
		{
    		repaint();
    		m_Graphics = getGraphics();
    		m_Images   = new Image[NUM_IMAGES];

    		MediaTracker tracker = new MediaTracker(this);
    		String strImage;

    		for (int i = 1; i <= NUM_IMAGES; i++)
    		{
    			strImage = "images/img" + ((i < 10) ? "0" : "") + i + ".gif";
   				m_Images[i-1] = getImage(getDocumentBase(), strImage);

                tracker.addImage(m_Images[i-1], 0);
    		}

			try
			{
				tracker.waitForAll();
				m_fAllLoaded = !tracker.isErrorAny();
			}
			catch (InterruptedException e)
			{
			}
			
			if (!m_fAllLoaded)
			{
			    stop();
			    m_Graphics.drawString("Error loading images!", 10, 40);
			    return;
			}
			
		    m_nImgWidth  = m_Images[0].getWidth(this);
		    m_nImgHeight = m_Images[0].getHeight(this);
        }		
		repaint();
	}

	public boolean action(Event event, Object obj)
	{
		Object oTarget = event.target;
		if (oTarget instanceof Button)
		{
			m_bAns1.hide();
			m_bAns2.hide();
			m_bAns3.hide();

			Button buttonTarget = (Button)oTarget;
			String sButtonString = buttonTarget.getLabel();
			String testAnswer = "" + m_iCorrAns;
			if (sButtonString.compareTo(testAnswer) == 0)
			{
				m_iCorrect++;
				m_lQuestion.setText("");
				m_lAns1.setText("");
				m_lAns2.setText("");
				m_lAns3.setText("");
		  		
				if (m_cbSound.getState() == true )
					play(getCodeBase(), "audio/horn.au");
				animate(1, 4, 25);

				if ((m_iCorrect + m_iWrong) == m_iNumberOfQuestions)
				{
					finalScore();
					return true;
				}
				return true;
			}
			else
			{
				m_iWrong++;
				m_lQuestion.setText("");
				m_lAns1.setText("");
				m_lAns2.setText("");
				m_lAns3.setText("");
		  		
				String RightAnswer = "";
				switch (m_iCorrAns)
				{
					case 1:
						RightAnswer = m_sAnswer1;
						break;
					case 2:
						RightAnswer = m_sAnswer2;
						break;
					case 3:
						RightAnswer = m_sAnswer3;
						break;
					default:
						break;
				}
				String wrongAnswer = "La reponse correcte est: " + RightAnswer;
				m_lQuestion.setText(wrongAnswer);
				
				if (m_cbSound.getState() == true )
					play(getCodeBase(), "audio/siren1.au");
				animate(5, 7, 50);

				if ((m_iCorrect + m_iWrong) == m_iNumberOfQuestions)
				{
					finalScore();
					return false;
				}
				return false;
			}
		}
		return false;
	}

	private void notRandom()
	{
		m_iaRandNums = new int[m_iNumberOfQuestions];
		int i = 0;

		for (int y = 1; y <= m_iNumberOfQuestions; y++)
		{
				m_iaRandNums[i] = i;
				i++;
		}
	}

	private void randomize()
	{
		m_iaRandNums = new int[m_iNumberOfQuestions];
		int testNumber = 0;
		boolean duplicate = true;
		boolean noduplicate = true;
		int i = 0;

		for (int y = 1; y <= m_iNumberOfQuestions; y++)
		{
			duplicate = true;
			while (duplicate == true)
			{
				noduplicate = true;
				m_iaRandNums[i] = (int) (Math.random() * m_iNumberOfQuestions);
				for (int x = 0; x < i; x++)
				{
					if (m_iaRandNums[i] == m_iaRandNums[x])
						noduplicate = false;
				}
				if (noduplicate == false)
					duplicate = true;
				else
				{
					duplicate = false;
					i++;
				}
			}
		}
	}

	public void finalScore()
	{
		m_lQuestion.setText("");
		m_lQofN.setText("");
		m_bAns1.hide();
		m_bAns2.hide();
		m_bAns3.hide();
		m_cbSound.hide();

		float z = 100 * m_iCorrect/(m_iWrong + m_iCorrect);
		Float a = new Float(z);

		int b = a.intValue();

		String c = "";
		c = c + b;

		Font font = new Font( "Courier", 1, 16);
		m_Graphics.setFont(font);
		m_Graphics.clearRect((size().width - m_nImgWidth) / 2, 22, 
			((size().width - m_nImgWidth) / 2) + m_nImgWidth, (22 + m_nImgHeight));
		m_Graphics.setColor(Color.red);			
		
		if (b < m_iScoreTarget)
			m_Graphics.drawImage(m_Images[9], 2, 22, null);
		else
			m_Graphics.drawImage(m_Images[8], 2, 22, null);

		m_Graphics.drawString("Your final score is: " + c + "%.", 50, 50);
		
		if (m_cbSound.getState() == true )
			play(getCodeBase(), "audio/fanfare.au");
		return;
	}

	public void getQuestion(int qn)
	{
		int iQuestNo = qn;
		int iSemicolonIndex = qn * 5;
		String tempCAns = "";

		m_caQuestionTemp = new char[200];
		int i = 0;
		int iSemicolon = 0;

		while (iSemicolon < iSemicolonIndex)
		{
			if (m_sInputString.charAt(i) == 59)
				iSemicolon++;
			i++;
		}

		iSemicolon = 0;
		int k = 0;

		while (iSemicolon < 5)
		{
			if (m_sInputString.charAt(i) == 59)
			{
				m_caQuestionTemp = new char[200];
				k=0;
				iSemicolon++;
				i++;
			}
			else
			{
				m_caQuestionTemp[k] = m_sInputString.charAt(i);
				i++;
				k++;
			}
			String sTempString = String.copyValueOf(m_caQuestionTemp);
			switch (iSemicolon)
			{
				case 0: 
					m_sQuestion = sTempString.trim();
					break;
				case 1:
					m_sAnswer1 = sTempString.trim();
					break;
				case 2:
					m_sAnswer2 = sTempString.trim();
					break;
				case 3:
					m_sAnswer3 = sTempString.trim();
					break;
				case 4:
					tempCAns = sTempString.trim();
					break;
			}
		}
		m_iCorrAns = Integer.parseInt(tempCAns);
		return;
	}
	
	public void getNumberOfQuestions()
	{
		m_iNumberOfQuestions = 0;

		for (int i = 0; i < m_sInputString.length(); i++)
		{
			if (m_sInputString.charAt(i) == 59)
				m_iNumberOfQuestions++;
		}
		m_iNumberOfQuestions = m_iNumberOfQuestions / 5;
		return;
	}

}
